Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Static Public Member Functions

# MemoryUsage Class Reference

This class is used strictly for debugging purposes, specifically for tracking memory leaks of reference-counted objects: it keeps a record of every such object currently allocated. More...

Inheritance diagram for MemoryUsage:

List of all members.

## Static Public Member Functions
static | freeze ()
| 'Freezes' all pointers currently stored so that they are no longer reported; only newly allocate pointers from this point on will appear in future information requests.
static unsigned int | getCurrentCppSize ()
| Returns the total number of bytes of allocated memory consumed by C++ objects, not including the memory previously frozen.
static unsigned int | getExternalSize ()
| Returns the total number of bytes of allocated memory in the heap that Panda didn't seem to be responsible for.
static int | getNumPointers ()
| Returns the number of pointers currently active.
static unsigned int | getPandaHeapArraySize ()
| Returns the total number of bytes allocated from the heap from code within Panda, for arrays.
static unsigned int | getPandaHeapOverhead ()
| Returns the extra bytes allocated from the system that are not immediately used for holding allocated objects.
static unsigned int | getPandaHeapSingleSize ()
| Returns the total number of bytes allocated from the heap from code within Panda, for individual objects.
static unsigned int | getPandaMmapSize ()
| Returns the total number of bytes allocated from the virtual memory pool from code within Panda.
static | getPointers (MemoryUsagePointers result)
| Fills the indicated MemoryUsagePointers with the set of all pointers currently active.
static | getPointersOfAge (MemoryUsagePointers result, double from, double to)
| Fills the indicated MemoryUsagePointers with the set of all pointers that were allocated within the range of the indicated number of seconds ago.
static | getPointersOfType (MemoryUsagePointers result, TypeHandle type)
| Fills the indicated MemoryUsagePointers with the set of all pointers of the indicated type currently active.
static | getPointersWithZeroCount (MemoryUsagePointers result)
| Fills the indicated MemoryUsagePointers with the set of all currently active pointers (that is, pointers allocated since the last call to freeze(), and not yet freed) that have a zero reference count.
static unsigned int | getTotalCppSize ()
| Returns the total number of bytes of allocated memory consumed by C++ objects, including the memory previously frozen.
static unsigned int | getTotalSize ()
| Returns the total size of allocated memory consumed by the process, as nearly as can be determined.
static bool | isCounting ()
| Returns true if the MemoryUsage object is currently at least counting memory (e.g.
static bool | isTracking ()
| Returns true if the MemoryUsage object is currently tracking memory (e.g.
static | showCurrentAges ()
| Shows the breakdown of ages of all of the active pointers.
static | showCurrentTypes ()
| Shows the breakdown of types of all of the active pointers.
static | showTrendAges ()
| Shows the breakdown of ages of all of the pointers allocated and freed since the last call to freeze().
static | showTrendTypes ()
| Shows the breakdown of types of all of the pointers allocated and freed since the last call to freeze().

## Detailed Description

This class is used strictly for debugging purposes, specifically for tracking memory leaks of reference-counted objects: it keeps a record of every such object currently allocated.

When compiled with NDEBUG set, this entire class does nothing and compiles to nothing.

## Member Function Documentation

static freeze | ( |  | ) | `[static]`

'Freezes' all pointers currently stored so that they are no longer reported; only newly allocate pointers from this point on will appear in future information requests.

This makes it easier to differentiate between continuous leaks and one-time memory allocations.

static unsigned int getCurrentCppSize | ( |  | ) | `[static]`

Returns the total number of bytes of allocated memory consumed by C++ objects, not including the memory previously frozen.

static unsigned int getExternalSize | ( |  | ) | `[static]`

Returns the total number of bytes of allocated memory in the heap that Panda didn't seem to be responsible for.

This includes a few bytes for very low-level objects (like ConfigVariables) that cannot use Panda memory tracking because they are so very low-level.

This also includes all of the memory that might have been allocated by a high-level interpreter, like Python.

This number is only available if Panda is able to hook into the actual heap callback.

static int getNumPointers | ( |  | ) | `[static]`

Returns the number of pointers currently active.

static unsigned int getPandaHeapArraySize | ( |  | ) | `[static]`

Returns the total number of bytes allocated from the heap from code within Panda, for arrays.

static unsigned int getPandaHeapOverhead | ( |  | ) | `[static]`

Returns the extra bytes allocated from the system that are not immediately used for holding allocated objects.

This can only be determined if ALTERNATIVE_MALLOC is enabled.

static unsigned int getPandaHeapSingleSize | ( |  | ) | `[static]`

Returns the total number of bytes allocated from the heap from code within Panda, for individual objects.

static unsigned int getPandaMmapSize | ( |  | ) | `[static]`

Returns the total number of bytes allocated from the virtual memory pool from code within Panda.

static getPointers | ( | MemoryUsagePointers | result | ) | `[static]`

Fills the indicated MemoryUsagePointers with the set of all pointers currently active.

static getPointersOfAge | ( | MemoryUsagePointers | result,
|  | double | from,
|  | double | to
| ) |  | `[static]`

Fills the indicated MemoryUsagePointers with the set of all pointers that were allocated within the range of the indicated number of seconds ago.

static getPointersOfType | ( | MemoryUsagePointers | result,
|  | TypeHandle | type
| ) |  | `[static]`

Fills the indicated MemoryUsagePointers with the set of all pointers of the indicated type currently active.

static getPointersWithZeroCount | ( | MemoryUsagePointers | result | ) | `[static]`

Fills the indicated MemoryUsagePointers with the set of all currently active pointers (that is, pointers allocated since the last call to freeze(), and not yet freed) that have a zero reference count.

Generally, an undeleted pointer with a zero reference count means its reference count has never been incremented beyond zero (since once it has been incremented, the only way it can return to zero would free the pointer). This may include objects that are allocated statically or on the stack, which are never intended to be deleted. Or, it might represent a programmer or compiler error.

This function has the side-effect of incrementing each of their reference counts by one, thus preventing them from ever being freed--but since they hadn't been freed anyway, probably no additional harm is done.

static unsigned int getTotalCppSize | ( |  | ) | `[static]`

Returns the total number of bytes of allocated memory consumed by C++ objects, including the memory previously frozen.

static unsigned int getTotalSize | ( |  | ) | `[static]`

Returns the total size of allocated memory consumed by the process, as nearly as can be determined.

static bool isCounting | ( |  | ) | `[static]`

Returns true if the MemoryUsage object is currently at least counting memory (e.g.

this is a Windows debug build), even if it's not fully tracking it.

static bool isTracking | ( |  | ) | `[static]`

Returns true if the MemoryUsage object is currently tracking memory (e.g.

track-memory-usage is configured #t).

static showCurrentAges | ( |  | ) | `[static]`

Shows the breakdown of ages of all of the active pointers.

static showCurrentTypes | ( |  | ) | `[static]`

Shows the breakdown of types of all of the active pointers.

static showTrendAges | ( |  | ) | `[static]`

Shows the breakdown of ages of all of the pointers allocated and freed since the last call to freeze().

static showTrendTypes | ( |  | ) | `[static]`

Shows the breakdown of types of all of the pointers allocated and freed since the last call to freeze().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties